#include "algfns.h"

//Global variables
extern GRAPH G;

void evaluate(SOL &S)
{
	int v, u, i;
	S.numHappy = G.n;
	//Do a full evaluation of a solution S and update the relevant data structures
	for (v = 0; v < G.n; v++) {
		//Assume v is happy until determined otherwise
		S.isHappy[v] = true;
		for (i = 0; i < G.adjList[v].size(); i++) {
			u = G.adjList[v][i];
			if (S.col[v] != S.col[u]) {
				//v is adjacent to a different colour vertex so it is unhappy. 
				S.isHappy[v] = false;
				S.numHappy--;
				break;
			}
		}
	}
}
